config/routes.rb
Rails.application.routes.draw do
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html

  post '/result' => 'payments#result'
  post '/payments' => 'payments#index'
  resources :transaction

  get '/transactions', to: 'transactions#index', as: 'transactions'
  root 'payments#index'
  post 'payments/validate'

  # get '/login' => 'login# index'
  # get '/users' => 'users# new'
  get '/login' => 'sessions#new'
  get '/auth/:provider/callback' => 'sessions#create'
  get 'auth/failure', to: redirect('/')
  delete 'signout', to: 'sessions#destroy', as: 'signout'
end

app/models/application_record.rb
# This is ApplicationRecord class
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/history.rb
# This is class History
class History < ApplicationRecord
  validates :invoice, presence: true
  validates :text, presence: true
end

app/models/status.rb
class Status < ApplicationRecord
end

app/models/transaction_detail.rb
class TransactionDetail < ApplicationRecord
	validates :invoice, presence: true
	validates :name, presence: true, format: { with: /\A[a-zA-Z ]+\z/, message: "only allows text" }

	validates :address, presence: true, format: { with: /\A[A-Za-z0-9., ]{5,30}\z/, message: "only allows text" }
	validates :phone, presence: true, format: { with: /\A[0-9]{5,15}\z/, message: "only allows number" }
	validates :email, presence: true, format: { with: /\A([A-Za-z0-9._-]{1,20}\@)+([A-Za-z0-9._-]{1,20})+\.([A-Za-z0-9._-]{1,5})+\z/, message: "only allows correct email"}
	validates :products, presence: true
	validates :detail, presence: true
	validates :status, presence: true
end

app/models/transaksi.rb
class Transaksi < ApplicationRecord
	validates :time, presence: true
	validates :source, presence: true
	validates :method, presence: true
	validates :subject, presence: true, format: { with: /\A([A-Za-z0-9._-]{1,20}\@)+([A-Za-z0-9._-]{1,20})+\.([A-Za-z0-9._-]{1,5})+\z/, message: "only allows correct email"}
	validates :amount, presence: true, numericality: { only_integer: true }
	validates :status, presence: true
end

app/models/user.rb
class User < ActiveRecord::Base
  def self.from_omniauth(auth)
    where(provider: auth.provider, uid: auth.uid).first_or_initialize.tap do |user|
      user.email = auth.info.email
      user.uid = auth.uid
      user.provider = auth.provider
      user.avatar_url = auth.info.image
      user.username = auth.info.name
      user.oauth_token = auth.credentials.token
      user.save!
    end
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception
  helper_method :current_user

  def current_user
    session[:user_id].nil? ? nil : User.find(session[:user_id])
  end


end

app/controllers/finnet_connect.rb
require 'digest'
require 'net/http'
require 'date'

def hash_data(data)
  result = Digest::SHA256.hexdigest(data)
  return result
end

def send_post(url, data)
	begin
		postData = Net::HTTP.post_form(URI.parse(url), data)
	rescue Errno::ECONNRESET => e
		postData = "ECONNRESET"
		return postData
	end
	return postData.body
end

def upper_data(data)
  secret_key = 'KF2017'
  string = ''
  data.each do |key, value|
    if value.to_s != ''
      string << value.to_s << '%'
	end
  end
  string = string << secret_key
  return string.upcase
end

def hash_maker_main(transaksi, detail)
	data = Hash.new
	
	data['add_info1'] = detail[:name] 
	data['add_info2'] = detail[:address]
	data['add_info3'] = detail[:phone]
	data['add_info4'] = detail[:email]
	data['amount'] = transaksi[:amount]
	data['failed_url'] = 'http://paybuddy.herokuapp.com/result'
	data['invoice'] = detail[:invoice]
	data['items'] = "%5B%5B%22chicken%22,100,1%5D%5D" # Items Test for T Cash
	data['merchant_id'] = 'KF820'
	data['return_url'] = 'http://paybuddy.herokuapp.com/result'
	data['sof_id'] = transaksi[:method]
	data['sof_type'] = 'pay'
	data['success_url'] = 'http://paybuddy.herokuapp.com/result'
	data['timeout'] = 100
	data['trans_date'] = transaksi[:time].strftime("%Y%m%d%H%M%S") 
	data['mer_signature'] = ''
	return data
end

def hash_maker_sc(merchant_id, payment_code)
	data = Hash.new
	
	data['mer_signature'] = ''
	data['merchant_id'] = merchant_id
	data['payment_code'] = payment_code
	return data
end

app/controllers/payments_controller.rb
require_relative 'finnet_connect'
require 'json'

class PaymentsController < ApplicationController
  skip_before_action :verify_authenticity_token
  before_action :set_locale

  def set_locale
    I18n.locale = params[:locale] || I18n.default_locale
  end

  def validate
    @transaksi = Transaksi.new(time: Time.now, invoice: params[:invoice], source: params[:source],
                               method: params[:trax_type], subject: params[:add_info4],
                               amount: params[:amount], status: 'WAITING_SUBJECT')
    @detail = TransactionDetail.new(invoice: params[:invoice], name: params[:add_info1],
                                    address: params[:add_info2], phone: params[:add_info3], email: params[:add_info4],
                                    products: params[:desc], detail: '-', status: 'WAITING_SUBJECT')
    @time = Time.now
    @text = "#{@time.strftime('%H:%M:%S')} Customer Choose #{params[:trax_type]}"
    @history = History.new(invoice: params[:invoice], text: @text)

    if @transaksi.save
      if @detail.save
        @history.save
      	data = hash_maker_main(@transaksi, @detail)
        data['mer_signature'] = hash_data(upper_data(data))
        post = send_post('https://sandbox.finpay.co.id/servicescode/api/apiFinpay.php', data)

        if post == 'ECONNRESET'
    	 	 render 'err_reset'
         @transaksi.destroy
         @history.destroy
         @detail.destroy
        else
          post = JSON.parse(post)
          if @transaksi[:method] == 'finpay195' || @transaksi[:method] == 'finpay021'
    		  	@code = post['payment_code']
            if post['status_desc'] == 'Success'
    			   	@status = 'Waiting for Payment'
    			  else
    				  @status = post['status_desc']
    			  end 
            render 'code'
          elsif @transaksi[:method] == 'tcash'
            url = post['redirect_url']
            redirect_to url
          else
            render plain: post
          end
        end
			else
		  	@transaksi.destroy
		  end
	  end

  end

  def result
	  @time = Time.now
    if @transaksi = Transaksi.find_by(invoice: params['invoice'])
      if @detail = TransactionDetail.find_by(invoice: params['invoice'])
        if params['result_code'] == '00'
      		@transaksi[:status] = 'PAID'
      		@detail[:status] = 'PAID'
      		@text = "#{@time.strftime('%H:%M:%S')} Payment has been made"
      		@history = History.new(invoice: params['invoice'], text: @text)
        else
      		@transaksi[:status] = 'REJECTED'
      		@detail[:status] = 'REJECTED'
      		@text = "#{@time.strftime('%H:%M:%S')} Payment Failed"
      		@history = History.new(invoice: params['invoice'], text: @text)
    	  end
      	@transaksi.save
      	@detail.save
      	@history.save
      end
    end
  end

  def index
    if params.key?(:invoice) && params.key?(:desc) && params.key?(:amount) && params.key?(:source)
      @source = params[:source]
      @invoice = params[:invoice]
      @desc = params[:desc]
      @amount = params[:amount]
    else
      @invoice = 153_813_51
      @desc = 'Barang 5 1 3'
      @amount = 121_231_3
      @source = 'Peentar'
    end
  end

end

app/controllers/sessions_controller.rb
class SessionsController < ApplicationController 
  def new
  end

  def create
    user = User.from_omniauth(request.env["omniauth.auth"])

    if user.valid?
      session[:user_id] = user.id
      redirect_to request.env['omniauth.origin']
    end
  end

  def destroy
    reset_session
    redirect_to request.referer
  end
end

app/controllers/transaction_controller.rb
class TransactionController < ApplicationController
  def index
    @transactions = Transaksi.all
  end

  def show
    @transaction = TransactionDetail.find_by(invoice: params[:id])
    @histories = History.where(invoice: params[:id])
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/login_helper.rb
module LoginHelper
end

app/helpers/payments_helper.rb
module PaymentsHelper
end

app/helpers/sessions_helper.rb
module SessionsHelper
end

app/helpers/transaction_helper.rb
# This is module TransactionHelper
module TransactionHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Paybuddy</title>
    <%= csrf_meta_tags %>
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css"> 
    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/payments/code.html.erb
<head>
  <title>Login</title>
</head>


<div class="gambar1">
	<%= image_tag("peentar.png", :alt => "logo") %>
</div>

<div class='login-page'>
  <div class='form'>
	<h1>FinPay Payment Code</h1><br>
	<p>Payment Code: <%=@code%></p>
	<p>Status: <%=@status%></p>
  </div>
</div>
<br>
<br>
<br>
<br>
<br>
<br>
<div class="footer-bottom">
	<div class="container">
		<p class="pull-left"> Copyright © Dream Fasilkom - UI. </p>
		<div class="pull-right">
			<ul class="nav nav-pills payments">
				<li><i class="fa fa-cc-visa"></i></li>
				<li><i class="fa fa-cc-mastercard"></i></li>
				<li><i class="fa fa-cc-amex"></i></li>
				<li><i class="fa fa-cc-paypal"></i></li>
			</ul> 
		</div>
	</div>
</div>

app/views/payments/err_reset.html.erb
<h1>500 Internal Server Error</h1>
<p> Connection reset by peer - SSL_connect </p>

app/views/payments/index.html.erb
<div class="gambar">
<%= image_tag("peentar.png", :alt => "logo") %>
</div>


<%= form_tag '/payments/validate', :id => "main_form" do %>

  	<div class="container-fluid center">
	  	<div class = "row">

	  		<div class="col-md-6">
	  			<div class = "row">
	  				<div class="col-md-12">
			  			<div class="box">
			  				<h3 class="group_title"><%=t'order'%></h3>
			  				<hr>
			  				<p class="group_items">
			  					<%=t'invoice'%>: <%=@invoice%>
			  				</p>
			  				<hr>

			  				<p class="group_items">
			  					<%=t'description'%>: <%=@desc%>
			  				</p>
			  				<hr>

			  				<p class="group_items">
			  					<%=number_to_currency(@amount, unit: "Rp.", precision: 0)%>
			  				</p> 
			  			</div>
		  			</div>
	  			</div>

				<div class="row">
					<div class="col-md-12">
			  			<div class="box">
			  				<h3 class="group_title"><%=t'detail'%></h3>
			  				<hr>

			  				<%= hidden_field_tag "invoice", @invoice %>
			  				<%= hidden_field_tag "amount", @amount %>
			  				<%= hidden_field_tag "source", @source %>
			  				<%= hidden_field_tag "desc", @desc %>
			  				
			  				<p class="group_items">
			  					<label for="data_inputs_name"><%=t'name'%></label><br>
			  					<%= text_field_tag "add_info1", params["add_info1"], id: 'name', :onkeyup => "validate(document.getElementById('name').value, /[a-zA-Z]+$/, 'name_err_msg')" %>
			  				</p>
							<p id="name_err_msg" value="false"><p>

							<p class="group_items">
			  					<label for="data_inputs_address"><%=t'addr'%></label><br>
			  					<%= text_field_tag "add_info2", params["add_info2"], id: 'addr', :onkeyup => "validate(document.getElementById('addr').value, /^[A-Za-z0-9.,\ ]{5,30}$/, 'address_err_msg')" %>
			  				</p>
							<p id="address_err_msg" value="false"><p>
							
			  				<p class="group_items">
			  					<label for="data_inputs_phone"><%=t'phone'%></label><br>
			  					<%= text_field_tag "add_info3", params["add_info3"], id: 'phone', :onkeyup => "validate(document.getElementById('phone').value, /^[0-9]{5,15}$/, 'phone_err_msg')" %>
			  				</p>
							<p id="phone_err_msg" value="false"><p>
							
			  				<p class="group_items">
			  					<label for="data_inputs_email"><%=t'email'%></label><br>
			  					<%= text_field_tag "add_info4", params["add_info4"], id: 'email', :onkeyup => "validate(document.getElementById('email').value, /^([A-Za-z0-9._-]{1,20}\@)+([A-Za-z0-9._-]{1,20})+\.([A-Za-z0-9._-]{1,5})+$/, 'email_err_msg')" %>
			  				</p>
			  				<p id="email_err_msg" value="false"><p>
	  			
	  				</div>
	  			</div>
	  		</div>
		
	  	</div>
	  		<div class="col-md-6">

	  			<div class="box">
		  			<h3 class="group_title"><%=t'method'%></h3>
		  			<hr>

		            <div class="radio"> 
		            	<label><%= radio_button_tag "trax_type", "klikpay", false, :onclick => "show('id1');check_v();", name: "trax_type"  %>BCA Klikpay</label>
		            </div>
		            <div id="id1" class="form-group">  
		            	<p class="payment_information">Use BCA Klikpay to pay</p>
		            </div>

		            <div class="radio"> 
		            	<label><%= radio_button_tag "trax_type", "mandiriclickpay", false, :onclick => "show('id2');check_v();", name: "trax_type"  %>Mandiri Klickpay</label>
		            </div>
		            <div id="id2" class="form-group">  
		            	<p class="payment_information">Use Mandiri Klickpay to pay</p>
		            </div>
		            
					<div class="radio">
						<label><%= radio_button_tag "trax_type", "vapermata", false, :onclick => "show('id3');check_v();", name: "trax_type"  %> Permata Virtual Account</label>
					</div>
					<div id="id3" class="form-group">
						<p class="payment_information">Use Permata Virtual Account to pay</p>
					</div>

					<div class="radio">
						<label><%= radio_button_tag "trax_type", "finpay195", false, :onclick => "show('id4');check_v();", name: "trax_type"  %> Finpay195</label>
					</div>
					<div id="id4" class="form-group">
						<p class="payment_information">Use Finpay195 to pay</p>
					</div>
					
					<div class="radio">
						<label><%= radio_button_tag "trax_type", "vabni", false, :onclick => "show('id5');check_v();", name: "trax_type"  %> BNI Virtual Account</label>
					</div>
					<div id="id5" class="form-group">
						<p class="payment_information">Use BNI Virtual Account to pay</p>
					</div>
					
					<div class="radio"> 
						<label><%= radio_button_tag "trax_type", "vabri", false, :onclick => "show('id6');check_v();", name: "trax_type"  %> BRI Virtual Account</label>
					</div>
					<div id="id6" class="form-group">
						<p class="payment_information">Use BRI Virtual Account to pay</p>
					</div>

					<div class="radio">
						<label><%= radio_button_tag "trax_type", "finpay021", false, :onclick => "show('id7');check_v();", name: "trax_type"  %> Finpay021</label>
					</div>
					<div id="id7" class="form-group">
						<p class="payment_information">Use Finpay021 to pay</p>
					</div>
					
					<div class="radio"> 
						<label><%= radio_button_tag "trax_type", "permatanet", false, :onclick => "show('id8');check_v();", name: "trax_type"  %>Permata Net</label> 
					</div>
					<div id="id8" class="form-group">  
						<p class="payment_information">Use Permata Net to pay</p>
					</div>
					
					<div class="radio"> 
						<label><%= radio_button_tag "trax_type", "tcash", false, :onclick => "show('id9');check_v();", name: "trax_type"  %>T-Cash</label> 
					</div>
					<div id="id9" class="form-group">  
						<p class="payment_information">Use T-Cash to pay</p>
					</div>
					
					<div class="radio"> 
						<label><%= radio_button_tag "trax_type", "sakuku", false, :onclick => "show('id10');check_v();", name: "trax_type"  %>Sakuku</label> 
					</div>
					<div id="id10" class="form-group">  
						<p class="payment_information">Use Sakuku to pay</p>
					</div>
					
					<div class="radio"> 
						<label><%= radio_button_tag "trax_type", "vastpermata", false, :onclick => "show('id11');check_v();", name: "trax_type"  %>Vast Permata</label> 
					</div>
					<div id="id11" class="form-group">  
						<p class="payment_information">Use Vast Permata to pay</p>
					</div>
					
		        	<div class="text-center">
				    	<%= submit_tag "Confirm", :class => "btn btn-primary", :id => "submit", :disabled => "true" %>
				  	</div>
	            </div>
	  		</div>
		</div>
  	</div>
<% end %>



<div class="footer-bottom">
	<div class="container">
		<p class="pull-left"> Copyright © Dream Fasilkom - UI. </p>
		<div class="pull-right">
			<ul class="nav nav-pills payments">
				<li><i class="fa fa-cc-visa"></i></li>
				<li><i class="fa fa-cc-mastercard"></i></li>
				<li><i class="fa fa-cc-amex"></i></li>
				<li><i class="fa fa-cc-paypal"></i></li>
			</ul> 
		</div>
	</div>
</div>

app/views/transaction/index.html.erb
  <% if current_user.blank? %>
    <div class="gambar1">
      <%= image_tag("peentar.png", :alt => "logo") %>
    </div>

      <div class="login-page">
        <div class='form'>
          <p>Silahkan Login terlebih dahulu</p>
          <%= link_to 'Login', '/login' %>
      </div>
    </div>
  <% else %>

  <div class="row head">
    <div class="col-md-6">
      <%= image_tag("peentar.png", :alt => "logo") %>
      <b><%= link_to 'Transaction Table', transaction_index_url  %></b>
    </div>
    <div class="col-md-6 write-right">
      <p>
        Logged in as <%= current_user.username %> 
        <%= link_to 'Sign Out', signout_path, method: :delete  %>
    </p>
    </div>
  </div>

    <div class='row'>
      <div id='top' class="jumbotron">
        <div class="container">                                                           
          <div class="table-responsive">
            <div class='kotak'>
              <h2 class='group_title text-center'>Transaction Table</h2> 
              <hr>     
              <table class="table">
                <thead class='text-center'>
                  <tr class='group_title active'>
                    <th>Time</th>
                    <th>InvoiceID</th>
                    <th>Source</th>
                    <th>Payment Method</th>
                    <th>Subject</th>
                    <th>Payment Amount</th>
                    <th>Status</th>
                    <th>Actionable</th>
                  </tr>
                </thead>
                <tbody>
                  <% @transactions.each do |t| %>
                  <tr>
                    <td><%= t.created_at %></td>
                    <td><%= t.invoice %></td>
                    <td><%= t.source %></td>
                    <td><%= t.method %></td>
                    <td><%= t.subject %></td>
                    <td><%= t.amount %></td>
                    <td><%= t.status %></td>
                    <td><%= link_to 'Detail', transaction_path(:id => t.invoice) %></td>
                    
                  </tr>
                  <% end %>
                </tbody>
              </table>
              <h4 class='group_title'>Status Detail</h4>
              <ul>
                <li class='col'>PENDING: When invoice has been made, but no payment method submitted</li>
                <li class='col2'>WAITING_SUBJECT: When invoice has been made, and a payment method has been commited, but we are not yet get payment notification from vendor (Finnet)</li>
                <li class='col'>PAID: When invoice has been made, and FinNet acknowledged that payment successfully</li>
                <li class='col2'>REJECTED: When invoice has been made, and FinNet acknowledged that payment was failed.</li>
              </ul>
            </div>
          </div>
        </div>
      </div>
    </div>

  <% end %>

    <div class="footer-bottom">
      <div class="container">
        <p align='center'> Copyright © Dream Fasilkom - UI </p>
      </div>
    </div>

app/views/transaction/show.html.erb
  <% if current_user.blank? %>
    <div class="gambar1">
      <%= image_tag("peentar.png", :alt => "logo") %>
    </div>

      <div class="login-page">
        <div class='form'>
          <p>Silahkan Login terlebih dahulu</p>
          <%= link_to 'Login', '/login' %>
      </div>
    </div>
  <% else %>

  <div class="row head">
    <div class="col-md-6">
      <%= image_tag("peentar.png", :alt => "logo") %>
      <b><%= link_to 'Transaction Table', transaction_index_url  %></b>
    </div>
    <div class="col-md-6 write-right">
      <p>
        Logged in as <%= current_user.username %> 
        <%= link_to 'Sign Out', signout_path, method: :delete  %>
    </p>
    </div>
  </div>

  <div class='row'>
    <div id='top' class="jumbotron">
      <div class="container">                                                           
        <div class="table-responsive">
          <div class='kotak'>
            <h2 class='group_title text-center'>Transaction Detail</h2> 
            <hr>     
            <table class="table">
             
              <tb class='group_title active'>
                  <tr>
          					<th>Invoice </th>
          					<td><%= @transaction.invoice %></td>
          				</tr>
          				<tr>
          					<th>Name </th>
          					<td><%= @transaction.name %></td>
          				</tr>
          				<tr>
          					<th>Address </th>
          					<td><%= @transaction.address %></td>
          				</tr>
          				<tr>
          					<th>Phone </th>
          					<td><%= @transaction.phone %></td>
          				</tr>
          				<tr>
          					<th>Email </th>
          					<td><%= @transaction.email %></td>
          				</tr>
          				<tr>
          					<th>Products </th>
          					<td><%= @transaction.products %></td>
          				</tr>
          				<tr>
          					<th>Status </th>
          					<td><%= @transaction.status %></td>
          				</tr>
          		</tb>
            </table>
            <br>
            <h4 class='group_title'>Status Detail</h4>
            <ul>
              <li class='col'>PENDING: When invoice has been made, but no payment method submitted</li>
              <li class='col2'>WAITING_SUBJECT: When invoice has been made, and a payment method has been commited, but we are not yet get payment notification from vendor (Finnet)</li>
              <li class='col'>PAID: When invoice has been made, and FinNet acknowledged that payment successfully</li>
              <li class='col2'>REJECTED: When invoice has been made, and FinNet acknowledged that payment was failed.</li>
            </ul>
          </div>
        </div>
      </div>
    </div>
  </div>



  <br>
  <br>
  <div class='row'>
    <div class='kotak'>
      <div class='container' id='mid'>
          <h2 class='group_title text-center'>Transaction History</h2> 
          <hr>
          
          <div> 
            <p>Transaction <%= @transaction.invoice %> </p>
            <% @histories.each do |h| %>
              <p><%= h.text %></p>
            <% end %>
          </div>
       
      </div>
    </div>
  </div>

  <br>
  <br>
  <br>
  <% end %>



  <div class="footer-bottom">
    <div class="container">
      <p align='center'> Copyright © Dream Fasilkom - UI </p>
    </div>
  </div>